<?php

// +----------------------------------------------------------------------
// | VitPHP
// +----------------------------------------------------------------------
// | 版权所有 2018~2021 藁城区创新网络电子商务中心 [ http://www.vitphp.cn ]
// +----------------------------------------------------------------------
// | VitPHP是一款免费开源软件,您可以访问http://www.vitphp.cn/以获得更多细节。
// +----------------------------------------------------------------------

namespace app\mz_nfc\controller;

use think\facade\Db;
use think\facade\View;
use vitphp\admin\controller\BaseController;
use app\ExcelExtend;

/**
 * @title 系统设置
 */
class Setup extends BaseController
{
    /**
     * @title 系统设置列表
     */
    public function index(){
        $pid = input('pid');
        $hdp = Db::name('mz_nfc_hdp')->where('pid',$pid)->select()->all();
        $setup = Db::name('mz_nfc_setup')->where(['pid'=>$pid])->find();
        $tuijian = Db::name('mz_nfc_tuijian')->where('pid',$pid)->select()->all();
        //判断是否post提交
        if(request()->isPost()){
            $param = [
                'title'=>input('title'),
                'fw_name'=>input('fw_name'),
                'fx_miaoshu'=>input('fx_miaoshu'),
                'fx_img'=>input('fx_img'),
                'index'=>input('index'),
                'copy'=>input('copy'),
                'pid'=>$pid
            ];
            if ($setup){
                $res = Db::name('mz_nfc_setup')->where('pid',$pid)->update($param);
            }else{
                $res = Db::name("mz_nfc_setup")->save($param);
            }
            if($res){
                $this->success("保存成功！", ToUrl('mz_nfc/setup/index'));
            }else{
                $this->error("保存失败！");
            }
        }
        View::assign([
            'hdp'=>!empty($hdp)? $hdp: '',
            'tuijian'=>!empty($tuijian)?$tuijian:'',
            'setup'=>!empty($setup)?$setup:'',
        ]);
	    return View::fetch();
	}
    /**
     * @title 幻灯片列表
     */
    public function hdp()
    {
        $pid = input('pid');
        $hdp = Db::name('mz_nfc_hdp')->where('pid',$pid)->select()->all();
        View::assign([
            'hdp'=>!empty($hdp)? $hdp: '',
        ]);
        return View::fetch();
	}
    /**
     * @title 新增/编辑幻灯片
     */
	public function edithdp(){
        $id = input('id');
        $pid = input('pid');
        $hdp = Db::name('mz_nfc_hdp')->where(['id'=>$id])->find();
        //判断是否post提交
        if(request()->isPost()){
            $param = [
                'img'=>input('img'),
                'urltype'=>input('urltype'),
                'app_path'=>input('app_path'),
                'app_appid'=>input('app_appid'),
                'app_paths'=>input('app_paths'),
                'h5_url'=>input('h5_url'),
                'time'=> time(),
                'pid'=>$pid
            ];
            if ($id){
                $res = Db::name('mz_nfc_hdp')->where('id',$id)->update($param);
            }else{
                $res = Db::name("mz_nfc_hdp")->save($param);
            }
            if($res){
                $this->success("保存成功！", ToUrl('mz_nfc/setup/hdp'));
            }else{
                $this->error("保存失败！");
            }
        }
        View::assign([
            'hdp'=>!empty($hdp)? $hdp: '',
        ]);
        return View::fetch();
    }
    /**
     * @title 删除幻灯片
     */
    public function delhdp(){
        $ids = $this->request->post('ids');
        $query = Db::name('mz_nfc_hdp')->where('id',$ids)->delete();
        if ($query){
            $this->success('删除成功');
        }else{
            $this->error('删除失败');
        }
    }
    /**
     * @title 广告列表
     */
    public function guanggao()
    {
        $pid = input('pid');
        $guanggao = Db::name('mz_nfc_guanggao')->where('pid',$pid)->select()->all();
        View::assign([
            'guanggao'=>!empty($guanggao)? $guanggao: '',
        ]);
        return View::fetch();
    }
    /**
     * @title 新增/编辑广告
     */
    public function editgg(){
        $id = input('id');
        $pid = input('pid');
        $guanggao = Db::name('mz_nfc_guanggao')->where(['id'=>$id])->find();
        //判断是否post提交
        if(request()->isPost()){
            $param = [
                'img'=>input('img'),
                'urltype'=>input('urltype'),
                'app_path'=>input('app_path'),
                'app_appid'=>input('app_appid'),
                'app_paths'=>input('app_paths'),
                'h5_url'=>input('h5_url'),
                'time'=> time(),
                'pid'=>$pid
            ];
            if ($id){
                $res = Db::name('mz_nfc_guanggao')->where('id',$id)->update($param);
            }else{
                $res = Db::name("mz_nfc_guanggao")->save($param);
            }
            if($res){
                $this->success("保存成功！", ToUrl('mz_nfc/setup/guanggao'));
            }else{
                $this->error("保存失败！");
            }
        }
        View::assign([
            'guanggao'=>!empty($guanggao)? $guanggao: '',
        ]);
        return View::fetch();
    }
    /**
     * @title 删除广告
     */
    public function delgg(){
        $ids = $this->request->post('ids');
        $query = Db::name('mz_nfc_guanggao')->where('id',$ids)->delete();
        if ($query){
            $this->success('删除成功');
        }else{
            $this->error('删除失败');
        }
    }
    /**
     * @title 服务推荐列表
     */
    public function tuijian()
    {
        $pid = input('pid');
        $tuijian = Db::name('mz_nfc_tuijian')->where('pid',$pid)->select()->all();
        View::assign([
            'tuijian'=>!empty($tuijian)?$tuijian:'',
        ]);
        return View::fetch();
    }
    /**
     * @title 新增/编辑推荐应用
     */
    public function edittj(){
        $id = input('id');
        $pid = input('pid');
        $tuijian = Db::name('mz_nfc_tuijian')->where(['id'=>$id])->find();
        //判断是否post提交
        if(request()->isPost()){
            $param = [
                'name'=>input('name'),
                'icon'=>input('icon'),
                'type'=>input('type'),
                'app_path'=>input('app_path'),
                'app_appid'=>input('app_appid'),
                'app_paths'=>input('app_paths'),
                'h5_url'=>input('h5_url'),
                'time'=> time(),
                'pid'=>$pid
            ];
            if ($id){
                $res = Db::name('mz_nfc_tuijian')->where('id',$id)->update($param);
            }else{
                $res = Db::name("mz_nfc_tuijian")->save($param);
            }
            if($res){
                $this->success("保存成功！", ToUrl('mz_nfc/setup/tuijian'));
            }else{
                $this->error("保存失败！");
            }
        }
        View::assign([
            'tuijian'=>!empty($tuijian)? $tuijian: '',
        ]);
        return View::fetch();
    }
    /**
     * @title 删除服务推荐
     */
    public function deltj(){
        $ids = $this->request->post('ids');
        $query = Db::name('mz_nfc_tuijian')->where('id',$ids)->delete();
        if ($query){
            $this->success('删除成功');
        }else{
            $this->error('删除失败');
        }
    }
}