<?php

namespace app\mz_nfc\controller;

use image\Image;
use think\facade\Db;
use think\facade\View;
use vitphp\admin\controller\BaseController;

class Url extends BaseController
{
    private $wechatConfig = [];

    /**
     * @title 链接管理
     */
    public function index(){
        $pid = input('pid');
        $pageNum = 50;
        $url = Db::name('mz_nfc_url')
            ->alias('a')->leftJoin('mz_nfc_user b ','a.uid = b.id')
            ->where('a.pid',$pid)->field('a.* , b.nickname , b.headimgurl')
            ->paginate($pageNum);
        View::assign([
            'url'=>!empty($url)? $url: '',
            'page' => $url->render(),
        ]);
        return View::fetch();
    }
    /**
     * @auth 0
     */
    public function ma(){
        $pid = input('pid');
        $id = input('id');
        $url = Db::name('mz_nfc_url')->where(['pid'=>$pid,'id'=>$id])->find();

        $maPath = public_path() . "app/mz_nfc/images/ma/{$pid}/";
        $maFile = $url['code'].".png";
        if(!file_exists($maPath.$maFile)) {
            $res = Db::name('mz_nfc_weixin')->where(['pid' => $pid])->find();

            $config = [
                'appsecret' => $res['wxapp_appsecret'],
                'appid' => $res['wxapp_appid'],
            ];
            $mini = new \WeMini\Qrcode($config);
            $path = '/pages/wifi/wifi?code=' . $url['code'];
            if (!file_exists($maPath)) {
                mkdir($maPath, 0755, true);
            }
            try {
                $ewmData = $mini->createMiniPath($path, 1000, false, ["r" => "0", "g" => "0", "b" => "0"], false);
                file_put_contents($maPath . $maFile, $ewmData);
            } catch (\Exception $e) {
                throw $e;
            }
        }

        View::assign([
           'url'=>"/app/mz_nfc/images/ma/{$pid}/{$url['code']}.png"
        ]);
        return View::fetch();
    }
    /**
     * @title 编辑链接
     */
    public function edit(){
        $id = input('id');
        $pid = input('pid');
        $url = Db::name('mz_nfc_url')->where(['id'=>$id])->find();
        //判断是否post提交
        if(request()->isPost()){
            $param = [
                'name'=>input('name'),
                'wifiid'=>input('wifiid'),
                'wifipass'=>input('wifipass'),
                'tel'=>input('tel'),
                'menu1'=>input('menu1'),
                'url1'=>input('url1'),
                'menu2'=>input('menu2'),
                'wxappid'=>input('wxappid'),
                'url2'=>input('url2'),
                'wxma'=>input('wxma'),
                'wxqun'=>input('wxqun'),
                'xiangqing'=>input('xiangqing'),
                'create_time'=>input('create_time'),
                'end_time'=>input('end_time'),
                'pid'=>$pid
            ];
            if ($id){
                Db::name('mz_nfc_url')->where('id',$id)->update($param);
            }else{
                $param['code'] = redom(8, 2);
                Db::name("mz_nfc_url")->save($param);
            }
            $this->success("保存成功！", ToUrl('mz_nfc/url/index'));
        }
        View::assign([
            'url'=>!empty($url)? $url: '',
        ]);
        return View::fetch();
    }
    /**
     * @title 删除链接
     */
    public function del(){
        $ids = $this->request->post('ids');
        $query = Db::name('mz_nfc_url')->where('id',$ids)->delete();
        if ($query){
            $this->success('删除成功');
        }else{
            $this->error('删除失败');
        }
    }
    /**
     * @title 批量生成
     */
    public function piliang(){
        $pid = input('pid');
        if($this->request->isPost()){
            $post = $this->request->post();
            $isPositiveInteger = is_numeric($post['length']) && is_int($post['length'] + 0) && ($post['length'] + 0) > 0;
            if(!$isPositiveInteger) $this->error('请输入正确的最小位数');
            if($post['length'] < 6) $this->error('位数不可小于6位');
            if(!$post['num']) $this->error('请输入要生成的数量');
            $data = [];
            $codes  = [];
            for($i=0;$i<$post['num'];$i++){
                $code = $post['qianzhui'].redom($post['length'], 2);
                if(in_array($code, $codes)){
                    $post['num'] ++;
                }else{
                    array_push($codes, $code);
                }
            }
            foreach($codes as $codeItem){
                $data[] = [
                    'pid' => $pid,
                    'code' => $codeItem,
                    'create_time' => time()
                ];
            }
            $codes = array_unique($codes);
            Db::name('mz_nfc_url')->insertAll($data);
            $this->success('操作成功');
        }
        return View::fetch();
    }

    public function bill()
    {
        $start = input('start', 1);
        $end = input('end', 2);
        $pid = input('pid');

        $qrcodeWidth = 800;
        if($qrcodeWidth > 1280) $this->error('二维码最大1280');
        $billPath = 'app' . DIRECTORY_SEPARATOR . app('http')->getName() . DIRECTORY_SEPARATOR . 'images' . DIRECTORY_SEPARATOR . 'bill' . DIRECTORY_SEPARATOR . $pid . DIRECTORY_SEPARATOR . '006' . DIRECTORY_SEPARATOR;

        $where = [
            ['id', '>=', $start],
            ['id', '<=', $end],
            ['pid', '=', $pid]
        ];
        $url = Db::name('mz_nfc_url')->where($where)->select();

        if($url->isEmpty()) return '数量为空';

        $billBackground = public_path() . 'app/mz_nfc/images/hbbg.jpg';
        if(!file_exists($billBackground)) $this->error('不存在的海报背景图');

        $this->wechatConfig = Db::name('mz_nfc_weixin')->where(['pid' => $pid])->find();

        $bills = [];
        foreach($url as $item){
            $fullMa = $this->getFullMa($item, $pid);
            $thumbMa = $this->getThumbMa($fullMa, $item ,$pid, $qrcodeWidth);
            $billFile = $this->createBill($billBackground, $billPath, $item, $thumbMa);
//            Db::name('mz_nfc_url')->where('id', $item['id'])->update([
//                'haibao' => '/' . $billFile
//            ]);
            array_push($bills, $billFile);
        }

        halt('生成成功', $bills);
    }

    private function createBill($billBackground, $path, $item, $maFile)
    {
        if(!file_exists(public_path() . $path)){
            mkdir(public_path() . $path, 0755, true);
        }

        $billFile = 'url_'.$item['id'] . $item['code'] . '.jpg';

        if(file_exists(public_path() . $path . $billFile)) return $path . $billFile;

        $bill = Image::open($billBackground);
        $bill->water($maFile, [488, 1000])->save(public_path() . $path . $billFile);
        return $path . $billFile;
    }

    private function getThumbMa($fullMa, $item, $pid, $width)
    {
        $maPath = public_path() . "app/mz_nfc/images/ma/{$pid}/";
        $maFile = $item['code'] . "_{$width}.png";
        if(file_exists($maPath . $maFile)) return $maPath . $maFile;

        $image = Image::open($fullMa);
        $image->thumb($width, $width, Image::THUMB_CENTER)->save($maPath . $maFile);

        return $maPath . $maFile;
    }

    private function getFullMa($item, $pid)
    {
        $maPath = public_path() . "app/mz_nfc/images/ma/{$pid}/";
        $maFile = $item['code'] . "_1280.png";
        if(file_exists($maPath . $maFile)) return $maPath . $maFile;

        $config = [
            'appsecret' =>  $this->wechatConfig['wxapp_appsecret'],
            'appid' =>  $this->wechatConfig['wxapp_appid'],
        ];
        $mini = new \WeMini\Qrcode($config);
        $path = '/pages/wifi/wifi?code=' . $item['code'];
        if (!file_exists($maPath)) {
            mkdir($maPath, 0755, true);
        }
        try {
            $ewmData = $mini->createMiniPath($path, 1280, false, ["r" => "0", "g" => "0", "b" => "0"], false);
            file_put_contents($maPath . $maFile, $ewmData);
        } catch (\Exception $e) {
            throw $e;
        }

        return $maPath . $maFile;
    }
}