<?php
// +----------------------------------------------------------------------
// | VitPHP
// +----------------------------------------------------------------------
// | 版权所有 2018~2021 藁城区创新网络电子商务中心 [ http://www.vitphp.cn ]
// +----------------------------------------------------------------------
// | VitPHP是一款免费开源软件,您可以访问http://www.vitphp.cn/以获得更多细节。
// +----------------------------------------------------------------------

namespace app\mz_nfc\controller;
use think\facade\Db;
use think\facade\View;
use vitphp\admin\controller\BaseController;
/**
 * @title 绑定小程序
 */
class Weixin extends BaseController
{
    /**
     * @title 对接微信小程序
     */
    public function index(){
        $pid = input('pid');
        $weixin = Db::name('mz_nfc_weixin')->where('pid',$pid)->find();
        if(request()->isPost()){
            $param = [
                'pid'=>input('pid'),
                'wxapp_name'=>input('wxapp_name'),
                'wxapp_appid'=>input('wxapp_appid'),
                'wxapp_appsecret'=>input('wxapp_appsecret'),
                'wxapp_mchid'=>input('wxapp_mchid'),
                'wxapp_apikey'=>input('wxapp_apikey'),
                'wxapp_private_key'=>input('wxapp_private_key'),
            ];
            if ($weixin){
                $res = Db::name('mz_nfc_weixin')->where('pid',$pid)->update($param);
            }else{
                $res = Db::name("mz_nfc_weixin")->save($param);
            }
            if($res){
                $this->success("保存成功！", ToUrl('/mz_nfc/weixin/index'));
            }else{
                $this->error("保存失败！");
            }
        }
        View::assign([
            'weixin'=>isset($weixin)?$weixin:'',
        ]);
        return View::fetch();
    }
    /**
     * @title 上传微信小程序
     */
    public function queryUpload()
    {
        $code = $this->getCode();
        if(!$code) json(['code'=>-1,'data'=>'请先登录应用市场']);

        $order = input('order');
        if(!$order) json(['code'=>-1,'data'=>'订单号不存在']);


        $url = config('vitphp.market').'api/wxapp/upload';
        $post = [
            'code' => $this->getCode(),
            'order' => $order
        ];
        $result = app_http_request($url, $post);
        $result = is_null(json_decode($result)) ? [] : json_decode($result, true);
        if(!$result || $result['code']!=1){
            $msg = $result['msg'] ?? '请求错误.';
            return json(['code'=>-1,'msg'=>$msg]);
        }
        return json(['code'=>1,'data'=>$result['data']]);
    }

    /**
     * @title 对接微信小程序
     */
    public function uploadWinpro()
    {
        $code = $this->getCode();
        if(!$code) $this->error('请先登录应用市场');
        $pid = input('pid');
        $appName = app('http')->getName();
        $addons = Db::name('addons')->where('identifie', '=', $appName)->find();
        $wechatConfig = Db::name('mz_nfc_weixin')->where('pid', '=', $pid)->find();
        if ($wechatConfig){
            if(!$wechatConfig['wxapp_appid']) $this->error('请先配置小程序appId');
            if(!$wechatConfig['wxapp_appsecret']) $this->error('请先配置小程序appSecret');
            if(!$wechatConfig['wxapp_private_key']) $this->error('请先配置小程序上传密钥');
        }else{
            $this->error('请先配置小程序参数');
        }
        if(request()->isPost()){
            $domain = $this->request->host();
            $configFiles = [
                [
                    'name' => 'config.js',
                    'path' => '/',
                    'content' => 'var siteinfo={"apiurl": "https://'.$domain.'/","pid": "'.$pid.'"};module.exports = siteinfo;'
                ],
            ];
            $url = config('vitphp.market').'api/wxapp';
            $post = [
                'code' => $this->getCode(),
                'goods' => $addons['goods_id'],
                'pid' => $pid,
                'appid' => $wechatConfig['wxapp_appid'],
                'wxapp_private_key' => $wechatConfig['wxapp_private_key'],
                'version' => input('version', ''),
                'desc' => input('desc'),
                'config_files' => json_encode($configFiles)
            ];
            if(!$post['version']) return json(['code'=>-1,'msg'=>'请填写版本号']);
            $result = app_http_request($url, $post);
            $result = is_null(json_decode($result)) ? [] : json_decode($result, true);

//            return json(['code'=>-1, 'msg'=>$result]);
            if(!$result || $result['code']!=1){
                $msg = $result['msg'] ?? '请求错误.';
                return json(['code'=>-1,'msg'=>$msg]);
            }
            return json(['code'=>1,'data'=>$result['data']]);
        }
        View::assign([
//            'addons'=>isset($addons)?$addons:''

        ]);
        return View::fetch();
    }
}