<?php
// +----------------------------------------------------------------------
// | VitPHP
// +----------------------------------------------------------------------
// | 版权所有 2018~2021 藁城区创新网络电子商务中心 [ http://www.vitphp.cn ]
// +----------------------------------------------------------------------
// | VitPHP是一款免费开源软件,您可以访问http://www.vitphp.cn/以获得更多细节。
// +----------------------------------------------------------------------

namespace app\mz_nfc\controller\wxapp;

use app\index\controller\api\AppAttachment;
use image\Image;
use think\facade\Db;
use think\facade\Request;

class Index extends Base
{
    protected $middleware = [
        \app\cx_dyfx\middleware\TokenCheck::class => ['only' => ['test']]
    ];

    /**
     * 获取应用配置信息
     * @return \think\response\Json
     */
    public function index()
    {
        header('Access-Control-Allow-Origin: *');
        $pid = input('pid');

        $setup = Db::name('mz_nfc_setup')->where('pid', $pid)->find();
        $setup['copy'] = str_replace("/upload", Request::domain() . "/upload", $setup['copy']);
        $setup['index'] = str_replace("/upload", Request::domain() . "/upload", $setup['index']);
        $setup['fx_img'] = $this->getFullMediaUrl($setup['fx_img']);

        $this->res['data'] = $setup;
        return $this->json();
    }

    public function tuijian()
    {
        header('Access-Control-Allow-Origin: *');
        $pid = input('pid');

        $tuijian = Db::name('mz_nfc_tuijian')->where('pid', $pid)->select();
        $tuijian = $tuijian->isEmpty() ? [] : $tuijian->toArray();
        foreach ($tuijian as &$item) {
            $item['icon'] = str_replace("/upload", Request::domain() . "/upload", $item['icon']);
        }

        $this->res['data'] = $tuijian;
        return $this->json();
    }

    /**
     * 获取首页banner
     */
    public function banner()
    {
        $pid = input('pid');
        $field = ['img', 'urltype', 'app_path', 'app_appid', 'app_paths', 'h5_url'];
        $banner = Db::name('mz_nfc_hdp')->where('pid', $pid)->field($field)->select();
        $banner = $banner->isEmpty() ? [] : $banner->toArray();
        foreach ($banner as &$item) {
            $item['img'] = $this->getFullMediaUrl($item['img']);
        }
        $this->res['data'] = $banner;
        return $this->json();
    }

    public function adBanner()
    {
        $pid = input('pid');
        $code = input('code');
        Db::name('mz_nfc_url')->where('pid', $pid)->where('code', $code)->update([
            'pv' => Db::raw('pv+1')
        ]);
        $url = Db::name('mz_nfc_url')->where('pid', $pid)->where('code', $code)->hidden(['id','pid','create_time', 'end_time'])->find();
        if(!$url) {
            $this->res['data'] = [];
            return json($this->res);
        }
        if(!$url['diqu']) {
            $this->res['data'] = [];
            return json($this->res);
        }

        $where = [
            ['diqu', '=', $url['diqu']],
            ['pc_hy', '<>', $url['hangye']],
            ['pc_hy', '<>', '']
        ];
        $gg = Db::name('mz_nfc_guanggao')->where($where)->whereNotNull('pc_hy')->select();
        $gg = $gg->isEmpty() ? [] : $gg->toArray();
        foreach ($gg as &$item) {
            $item['img'] = $this->getFullMediaUrl($item['img']);
        }
        $this->res['data'] = $gg;
        return json($this->res);
    }

    public function upload()
    {
        $openid = $this->decodeToken();
        if(!$openid){
            $this->res['code'] = -1;
            $this->res['data'] = '请先登录';
            return $this->json();
        }

        $appAttachment = new AppAttachment(app());
        $fileResult = $appAttachment->upload();

        if ($fileResult['code'] != 1) {
            $this->res['code'] = -1;
            $this->res['msg'] = $fileResult['msg'] ?? '图片上传失败';
            return $this->json();
        }

        $fileResult['code'] = 0;
        if($fileResult['data']['storage']!=1){
            $fileResult['data']['fileurl'] = $fileResult['data']['src'];
        }
        $fileResult['data']['url'] = $fileResult['data']['src'];
        $this->res = $fileResult;

        return $this->json();
    }
}