<?php
// +----------------------------------------------------------------------
// | VitPHP
// +----------------------------------------------------------------------
// | 版权所有 2018~2021 藁城区创新网络电子商务中心 [ http://www.vitphp.cn ]
// +----------------------------------------------------------------------
// | VitPHP是一款免费开源软件,您可以访问http://www.vitphp.cn/以获得更多细节。
// +----------------------------------------------------------------------


namespace app\mz_nfc\controller\wxapp;

use think\facade\Db;

class Login extends Base
{
    public function session()
    {
        $pid = input('pid');
        $sid = input('sid');
        $res = Db::name('mz_nfc_weixin')->where(['pid' => $pid])->find();

        $config = [
            'appsecret' => $res['wxapp_appsecret'],
            'appid' => $res['wxapp_appid'],
        ];

        try {
            $crypt = \We::WeMiniCrypt($config);

            $code = input('code');
            $wechatSessionInfo = $crypt->session($code);

            $where = [
                ['pid', '=', $pid],
                ['openid', '=', $wechatSessionInfo['openid']]
            ];

            $guestInfo = (new User(app()))->getInfoByOpenid($pid, $wechatSessionInfo['openid']);
            if (!$guestInfo) {
                Db::name('mz_nfc_user')->where($where)->insert([
                    'pid' => $pid,
                    'openid' => $wechatSessionInfo['openid'],
                    'sid' => $sid
                ]);
                $guestInfo = (new User(app()))->getInfoByOpenid($pid, $wechatSessionInfo['openid']);
            }
            if (!$guestInfo['sid'] && $sid && $guestInfo['id'] != $sid) {
                Db::name('mz_nfc_user')->where('id', $guestInfo['id'])->update([
                    'sid' => $sid
                ]);
            }
            $token = $this->getToken($wechatSessionInfo['openid']);
            $this->res['data'] = [
                'token' => $token,
                'user_info' => $guestInfo
            ];
        } catch (\Exception $e) {
            $this->res['code'] = '-1';
            $this->res['msg'] = $e->getMessage();
            throw $e;
        }

        return $this->json();
    }

    public function wxLogin()
    {
        $pid = input('pid');
        $system = input('system');
        $res = Db::name('mz_nfc_weixin')->where(['pid' => $pid])->find();
        $config = [
            'appsecret' => $res['wxapp_appsecret'],
            'appid' => $res['wxapp_appid'],
        ];

        try {
            $crypt = \We::WeMiniCrypt($config);

            $code = input('code');
            $iv = input('iv');
            $encryptedData = input('encrypted_data');
            $wechatInfo = $crypt->userInfo($code, $iv, $encryptedData);

            // 获取信息之后，判断一下，如果有openid就更新，没有就添加
            $where = [
                ['pid', '=', $pid],
                ['openid', '=', $wechatInfo['openid']]
            ];
            $guestInfo = Db::name('mz_nfc_user')->where($where)->find();
            if (!$guestInfo) {
                Db::name('mz_nfc_user')->insert([
                    'pid' => $pid,
                    'nickname' => $this->userTextEncode($wechatInfo['nickName']),
                    'openid' => $wechatInfo['openid'],
                    'headimgurl' => $wechatInfo['avatarUrl'],
                    'time' => time(),
//                    'jf_num' => $setup['mf_num'] ?? 0,
//                    'is_daili' => $setup['sq_daili'] == 3 ? 2 : 1,
                    'model' => $system['model'],
                    'system' => $system['system']
                ]);
            }
            $guestInfo = (new User(app()))->getInfoByOpenid($pid, $wechatInfo['openid']);
            $token = $this->getToken($wechatInfo['openid']);

            $this->res['data'] = [
                'token' => $token,
                'user_info' => $guestInfo
            ];
        } catch (\Exception $e) {
            $this->res['code'] = '-1';
            $this->res['msg'] = $e->getMessage();
        }

        return $this->json();
    }
}