<?php
// +----------------------------------------------------------------------
// | VitPHP
// +----------------------------------------------------------------------
// | 版权所有 2018~2021 藁城区创新网络电子商务中心 [ http://www.vitphp.cn ]
// +----------------------------------------------------------------------
// | VitPHP是一款免费开源软件,您可以访问http://www.vitphp.cn/以获得更多细节。
// +----------------------------------------------------------------------

namespace app\mz_nfc\controller\wxapp;


use image\Image;
use think\facade\Db;

class Url extends Base
{
    public function getList()
    {
        $pid = input('pid');
        $page = input('page', 1);
        $num = input('num', 1);
        $list = Db::name('mz_nfc_url')->where('pid', $pid)->order('id desc')->page($page, $num)->select()->toArray();
        $data = [];
        foreach($list as $item){
            $data[] = [
                'code' => $item['code'],
                'name' => $item['name']
            ];
        }

        $this->res['data'] = $data;
        return json($this->res);
    }

    public function getWifi()
    {
        $pid = input('pid');
        $code = input('code');
        Db::name('mz_nfc_url')->where('pid', $pid)->where('code', $code)->update([
            'pv' => Db::raw('pv+1')
        ]);
        $url = Db::name('mz_nfc_url')->where('pid', $pid)->where('code', $code)->hidden(['id','pid','create_time', 'end_time'])->find();
        if(!$url) {
            $this->res['data'] = [];
            return json($this->res);
        }
        $url['show_wxma'] = $this->getFullMediaUrl($url['wxma']);
        $url['show_wxqun'] = $this->getFullMediaUrl($url['wxqun']);
        $url['haibao'] = $this->getFullMediaUrl($url['haibao'], true);

        $this->res['data'] = $url;
        return json($this->res);
    }

    public function wifiInc()
    {
        $pid = input('pid');
        $code = input('code');
        Db::name('mz_nfc_url')->where('pid', $pid)->where('code', $code)->update([
            'lian_num' => Db::raw('lian_num+1')
        ]);

        return json($this->res);
    }

    public function createBill()
    {
        $pid = input('pid');
        $code = input('code');
        $url = Db::name('mz_nfc_url')->where('pid', $pid)->where('code', $code)->find();
        if(!$url) {
            $this->res['msg'] = '未知的wifi信息';
            $this->res['data'] = '';
            return json($this->res);
        }
        if($url['haibao']){
            $haibao = $this->getFullMediaUrl($url['haibao']);
            $this->res['data'] = [
                'haibao' => $haibao
            ];
            return json($this->res);
        }
        $billBackground = public_path() . 'app/mz_nfc/images/bg.jpg';
        if(!file_exists($billBackground)) jsonErrCode('不存在的海报背景图');

        $maPath = public_path() . "app/mz_nfc/images/ma/{$pid}/";
        $maFile = $url['code'].".png";
        if(!file_exists($maPath . $maFile)){
            $res = Db::name('mz_nfc_weixin')->where(['pid' => $pid])->find();

            $config = [
                'appsecret' => $res['wxapp_appsecret'],
                'appid' => $res['wxapp_appid'],
            ];
            $mini = new \WeMini\Qrcode($config);
            $path = '/pages/wifi/wifi?code=' . $url['code'];
            if (!file_exists($maPath)) {
                mkdir($maPath, 0755, true);
            }
            try {
                $ewmData = $mini->createMiniPath($path, 1280, false, ["r" => "0", "g" => "0", "b" => "0"], false);
                file_put_contents($maPath . $maFile, $ewmData);
            } catch (\Exception $e) {
                jsonErrCode('海报生成失败');
            }
        }

        $thumbMaFile = $url['code']."_470.png";
        if(!file_exists($maPath . $thumbMaFile)){
            $image = Image::open($maPath . $maFile);
            $image->thumb(470, 470, Image::THUMB_CENTER)->save($maPath . $thumbMaFile);
        }

        $billPath = 'app' . DIRECTORY_SEPARATOR . app('http')->getName() . DIRECTORY_SEPARATOR . 'bill' . DIRECTORY_SEPARATOR ;
        if(!file_exists(public_path() . $billPath)){
            mkdir(public_path() . $billPath, 0755, true);
        }
        $billFile = 'url_' . $url['code'] . '.png';
        $bill = Image::open($billBackground);
        $bill->water($maPath . $thumbMaFile, [350, 750])->save(public_path() . $billPath . $billFile);

         Db::name('mz_nfc_url')->where('id', $url['id'])->update([
             'haibao' => DIRECTORY_SEPARATOR . $billPath . $billFile
         ]);

        $this->res['data'] = [
            'haibao' => $this->getFullMediaUrl( '/' . $billPath . $billFile, true)
        ];
        return json($this->res);
    }
}